"use strict";
/* eslint-disable camelcase */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DeltaChat = void 0;
var binding_1 = __importDefault(require("../binding"));
var constants_1 = require("./constants");
var events_1 = require("events");
var chat_1 = require("./chat");
var chatlist_1 = require("./chatlist");
var contact_1 = require("./contact");
var message_1 = require("./message");
var lot_1 = require("./lot");
var fs_extra_1 = require("fs-extra");
var path_1 = __importDefault(require("path"));
var locations_1 = require("./locations");
var lodash_pick_1 = __importDefault(require("lodash.pick"));
var debug_1 = __importDefault(require("debug"));
var tempy_1 = __importDefault(require("tempy"));
var debug = debug_1.default('deltachat:node:index');
var noop = function () { };
var DC_SHOW_EMAILS = [
    constants_1.C.DC_SHOW_EMAILS_ACCEPTED_CONTACTS,
    constants_1.C.DC_SHOW_EMAILS_ALL,
    constants_1.C.DC_SHOW_EMAILS_OFF,
];
/**
 * Wrapper around dcn_context_t*
 */
var DeltaChat = /** @class */ (function (_super) {
    __extends(DeltaChat, _super);
    function DeltaChat() {
        var _this = this;
        debug('DeltaChat constructor');
        _this = _super.call(this) || this;
        _this._isOpen = false;
        _this.dcn_context = null;
        return _this;
    }
    DeltaChat.prototype.isOpen = function () {
        return this._isOpen;
    };
    DeltaChat.prototype.open = function (cwd, start_event_handler) {
        if (start_event_handler === void 0) { start_event_handler = true; }
        return __awaiter(this, void 0, void 0, function () {
            var dbFile;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this._isOpen === true) {
                            throw new Error("We're already open!");
                        }
                        return [4 /*yield*/, fs_extra_1.mkdirp(cwd)];
                    case 1:
                        _a.sent();
                        dbFile = path_1.default.join(cwd, 'db.sqlite');
                        this.dcn_context = binding_1.default.dcn_context_new(dbFile);
                        debug('Opened context');
                        if (start_event_handler) {
                            binding_1.default.dcn_start_event_handler(this.dcn_context, this.handleCoreEvent.bind(this));
                            debug('Started event handler');
                        }
                        this._isOpen = true;
                        return [2 /*return*/];
                }
            });
        });
    };
    DeltaChat.prototype.close = function () {
        if (this._isOpen === false) {
            throw new Error("We're already closed!");
        }
        debug('unrefing context');
        binding_1.default.dcn_context_unref(this.dcn_context);
        debug('Unref end');
        this._isOpen = false;
    };
    DeltaChat.prototype.emit = function (event) {
        var args = [];
        for (var _i = 1; _i < arguments.length; _i++) {
            args[_i - 1] = arguments[_i];
        }
        _super.prototype.emit.apply(this, __spreadArrays(['ALL', event], args));
        return _super.prototype.emit.apply(this, __spreadArrays([event], args));
    };
    DeltaChat.prototype.handleCoreEvent = function (eventId, data1, data2) {
        var eventString = constants_1.EventId2EventName[eventId];
        debug(eventString, data1, data2);
        if (!this.emit) {
            console.log('Received an event but EventEmitter is already destroyed.');
            console.log(eventString, data1, data2);
            return;
        }
        this.emit(eventString, data1, data2);
    };
    DeltaChat.prototype.startIO = function () {
        if (!this.isConfigured()) {
            throw new Error("Can't start io unless context is configured.");
        }
        binding_1.default.dcn_start_io(this.dcn_context);
    };
    DeltaChat.prototype.stopIO = function () {
        debug('stopIO()');
        binding_1.default.dcn_stop_io(this.dcn_context);
    };
    DeltaChat.prototype.addAddressBook = function (addressBook) {
        debug("addAddressBook " + addressBook);
        return binding_1.default.dcn_add_address_book(this.dcn_context, addressBook);
    };
    DeltaChat.prototype.addContactToChat = function (chatId, contactId) {
        debug("addContactToChat " + chatId + " " + contactId);
        return Boolean(binding_1.default.dcn_add_contact_to_chat(this.dcn_context, Number(chatId), Number(contactId)));
    };
    DeltaChat.prototype.addDeviceMessage = function (label, msg) {
        debug("addDeviceMessage " + label + " " + msg);
        if (!msg) {
            throw new Error('invalid msg parameter');
        }
        if (typeof label !== 'string') {
            throw new Error('invalid label parameter, must be a string');
        }
        if (typeof msg === 'string') {
            var msgObj = this.messageNew();
            msgObj.setText(msg);
            msg = msgObj;
        }
        if (!msg.dc_msg) {
            throw new Error('invalid msg object');
        }
        return binding_1.default.dcn_add_device_msg(this.dcn_context, label, msg.dc_msg);
    };
    DeltaChat.prototype.setChatVisibility = function (chatId, visibility) {
        debug("setChatVisibility " + chatId + " " + visibility);
        binding_1.default.dcn_set_chat_visibility(this.dcn_context, Number(chatId), visibility);
    };
    DeltaChat.prototype.blockContact = function (contactId, block) {
        debug("blockContact " + contactId + " " + block);
        binding_1.default.dcn_block_contact(this.dcn_context, Number(contactId), block ? 1 : 0);
    };
    DeltaChat.prototype.checkQrCode = function (qrCode) {
        debug("checkQrCode " + qrCode);
        var dc_lot = binding_1.default.dcn_check_qr(this.dcn_context, qrCode);
        var result = dc_lot ? new lot_1.Lot(dc_lot) : null;
        if (result) {
            return __assign({ id: result.getId() }, result.toJson());
        }
        return result;
    };
    DeltaChat.prototype.configure = function (opts) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            debug('configure');
            if (_this._isOpen !== true) {
                return reject(new Error("Can't start configuring unless we have an open context"));
            }
            var onSuccess = function () {
                removeListeners();
                resolve();
            };
            var onFail = function (error) {
                removeListeners();
                reject(new Error(error));
            };
            var onConfigure = function (data1, data2) {
                if (data1 === 0)
                    return onFail(data2);
                else if (data1 === 1000)
                    return onSuccess();
            };
            var removeListeners = function () {
                _this.removeListener('DC_EVENT_CONFIGURE_PROGRESS', onConfigure);
            };
            var registerListeners = function () {
                _this.on('DC_EVENT_CONFIGURE_PROGRESS', onConfigure);
            };
            registerListeners();
            if (!opts)
                opts = {};
            Object.keys(opts).forEach(function (key) {
                var value = opts[key];
                _this.setConfig(key, value);
            });
            binding_1.default.dcn_configure(_this.dcn_context);
        });
    };
    DeltaChat.prototype.continueKeyTransfer = function (messageId, setupCode) {
        var _this = this;
        debug("continueKeyTransfer " + messageId);
        return new Promise(function (resolve, reject) {
            binding_1.default.dcn_continue_key_transfer(_this.dcn_context, Number(messageId), setupCode, function (result) { return resolve(result === 1); });
        });
    };
    /** @returns chatId */
    DeltaChat.prototype.createChatByContactId = function (contactId) {
        debug("createChatByContactId " + contactId);
        return binding_1.default.dcn_create_chat_by_contact_id(this.dcn_context, Number(contactId));
    };
    /** @deprecated
     * @returns chatId */
    DeltaChat.prototype.createChatByMessageId = function (messageId) {
        debug("createChatByMessageId " + messageId);
        return binding_1.default.dcn_create_chat_by_msg_id(this.dcn_context, Number(messageId));
    };
    /** @returns contactId */
    DeltaChat.prototype.createContact = function (name, addr) {
        debug("createContact " + name + " " + addr);
        return binding_1.default.dcn_create_contact(this.dcn_context, name, addr);
    };
    /**
     *
     * @param chatName The name of the chat that should be created
     * @param is_protected Whether the chat should be protected at creation time
     * @returns chatId
     */
    DeltaChat.prototype.createGroupChat = function (chatName, is_protected) {
        if (is_protected === void 0) { is_protected = false; }
        debug("createGroupChat " + chatName + " [protected:" + is_protected + "]");
        return binding_1.default.dcn_create_group_chat(this.dcn_context, is_protected ? 1 : 0, chatName);
    };
    /**
     * @param messageId ID of Message to decide on.
     * @param decision One of the DC_DECISION_* values.
     * @return The chat id of the created chat, if any.
     */
    DeltaChat.prototype.decideOnContactRequest = function (messageId, decision) {
        return Number(binding_1.default.dcn_decide_on_contact_request(this.dcn_context, Number(messageId), Number(decision)));
    };
    DeltaChat.prototype.deleteChat = function (chatId) {
        debug("deleteChat " + chatId);
        binding_1.default.dcn_delete_chat(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.deleteContact = function (contactId) {
        debug("deleteContact " + contactId);
        return Boolean(binding_1.default.dcn_delete_contact(this.dcn_context, Number(contactId)));
    };
    DeltaChat.prototype.deleteMessages = function (messageIds) {
        if (!Array.isArray(messageIds)) {
            messageIds = [messageIds];
        }
        messageIds = messageIds.map(function (id) { return Number(id); });
        debug('deleteMessages', messageIds);
        binding_1.default.dcn_delete_msgs(this.dcn_context, messageIds);
    };
    DeltaChat.prototype.forwardMessages = function (messageIds, chatId) {
        if (!Array.isArray(messageIds)) {
            messageIds = [messageIds];
        }
        messageIds = messageIds.map(function (id) { return Number(id); });
        debug('forwardMessages', messageIds);
        binding_1.default.dcn_forward_msgs(this.dcn_context, messageIds, chatId);
    };
    DeltaChat.prototype.getBlobdir = function () {
        debug('getBlobdir');
        return binding_1.default.dcn_get_blobdir(this.dcn_context);
    };
    DeltaChat.prototype.getBlockedCount = function () {
        debug('getBlockedCount');
        return binding_1.default.dcn_get_blocked_cnt(this.dcn_context);
    };
    DeltaChat.prototype.getBlockedContacts = function () {
        debug('getBlockedContacts');
        return binding_1.default.dcn_get_blocked_contacts(this.dcn_context);
    };
    DeltaChat.prototype.getChat = function (chatId) {
        debug("getChat " + chatId);
        var dc_chat = binding_1.default.dcn_get_chat(this.dcn_context, Number(chatId));
        return dc_chat ? new chat_1.Chat(dc_chat) : null;
    };
    DeltaChat.prototype.getChatContacts = function (chatId) {
        debug("getChatContacts " + chatId);
        return binding_1.default.dcn_get_chat_contacts(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.getChatIdByContactId = function (contactId) {
        debug("getChatIdByContactId " + contactId);
        return binding_1.default.dcn_get_chat_id_by_contact_id(this.dcn_context, Number(contactId));
    };
    DeltaChat.prototype.getChatMedia = function (chatId, msgType1, msgType2, msgType3) {
        debug("getChatMedia " + chatId);
        return binding_1.default.dcn_get_chat_media(this.dcn_context, Number(chatId), msgType1, msgType2 || 0, msgType3 || 0);
    };
    DeltaChat.prototype.getMimeHeaders = function (messageId) {
        debug("getMimeHeaders " + messageId);
        return binding_1.default.dcn_get_mime_headers(this.dcn_context, Number(messageId));
    };
    DeltaChat.prototype.getChatlistItemSummary = function (chatId, messageId) {
        debug("getChatlistItemSummary " + chatId + " " + messageId);
        return new lot_1.Lot(binding_1.default.dcn_chatlist_get_summary2(this.dcn_context, chatId, messageId));
    };
    DeltaChat.prototype.getChatMessages = function (chatId, flags, marker1before) {
        debug("getChatMessages " + chatId + " " + flags + " " + marker1before);
        return binding_1.default.dcn_get_chat_msgs(this.dcn_context, Number(chatId), flags, marker1before);
    };
    /**
     * Get encryption info for a chat.
     * Get a multi-line encryption info, containing encryption preferences of all members.
     * Can be used to find out why messages sent to group are not encrypted.
     *
     * @param chatId ID of the chat to get the encryption info for.
     * @return Multi-line text, must be released using dc_str_unref() after usage.
     */
    DeltaChat.prototype.getChatEncrytionInfo = function (chatId) {
        return binding_1.default.dcn_get_chat_encrinfo(this.dcn_context, chatId);
    };
    DeltaChat.prototype.getChats = function (listFlags, queryStr, queryContactId) {
        debug('getChats');
        var result = [];
        var list = this.getChatList(listFlags, queryStr, queryContactId);
        var count = list.getCount();
        for (var i = 0; i < count; i++) {
            result.push(list.getChatId(i));
        }
        return result;
    };
    DeltaChat.prototype.getChatList = function (listFlags, queryStr, queryContactId) {
        listFlags = listFlags || 0;
        queryStr = queryStr || '';
        queryContactId = queryContactId || 0;
        debug("getChatList " + listFlags + " " + queryStr + " " + queryContactId);
        return new chatlist_1.ChatList(binding_1.default.dcn_get_chatlist(this.dcn_context, listFlags, queryStr, Number(queryContactId)));
    };
    DeltaChat.prototype.getConfig = function (key) {
        debug("getConfig " + key);
        return binding_1.default.dcn_get_config(this.dcn_context, key);
    };
    DeltaChat.prototype.getContact = function (contactId) {
        debug("getContact " + contactId);
        var dc_contact = binding_1.default.dcn_get_contact(this.dcn_context, Number(contactId));
        return dc_contact ? new contact_1.Contact(dc_contact) : null;
    };
    DeltaChat.prototype.getContactEncryptionInfo = function (contactId) {
        debug("getContactEncryptionInfo " + contactId);
        return binding_1.default.dcn_get_contact_encrinfo(this.dcn_context, Number(contactId));
    };
    DeltaChat.prototype.getContacts = function (listFlags, query) {
        listFlags = listFlags || 0;
        query = query || '';
        debug("getContacts " + listFlags + " " + query);
        return binding_1.default.dcn_get_contacts(this.dcn_context, listFlags, query);
    };
    DeltaChat.prototype.wasDeviceMessageEverAdded = function (label) {
        debug("wasDeviceMessageEverAdded " + label);
        var added = binding_1.default.dcn_was_device_msg_ever_added(this.dcn_context, label);
        return added === 1;
    };
    DeltaChat.prototype.getDraft = function (chatId) {
        debug("getDraft " + chatId);
        var dc_msg = binding_1.default.dcn_get_draft(this.dcn_context, Number(chatId));
        return dc_msg ? new message_1.Message(dc_msg) : null;
    };
    DeltaChat.prototype.getFreshMessageCount = function (chatId) {
        debug("getFreshMessageCount " + chatId);
        return binding_1.default.dcn_get_fresh_msg_cnt(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.getFreshMessages = function () {
        debug('getFreshMessages');
        return binding_1.default.dcn_get_fresh_msgs(this.dcn_context);
    };
    DeltaChat.prototype.getInfo = function () {
        debug('getInfo');
        var info = binding_1.default.dcn_get_info(this.dcn_context);
        return DeltaChat.parseGetInfo(info);
    };
    DeltaChat.parseGetInfo = function (info) {
        debug('static _getInfo');
        var result = {};
        var regex = /^(\w+)=(.*)$/i;
        info
            .split('\n')
            .filter(Boolean)
            .forEach(function (line) {
            var match = regex.exec(line);
            if (match) {
                result[match[1]] = match[2];
            }
        });
        return result;
    };
    DeltaChat.prototype.getMessage = function (messageId) {
        debug("getMessage " + messageId);
        var dc_msg = binding_1.default.dcn_get_msg(this.dcn_context, Number(messageId));
        return dc_msg ? new message_1.Message(dc_msg) : null;
    };
    DeltaChat.prototype.getMessageCount = function (chatId) {
        debug("getMessageCount " + chatId);
        return binding_1.default.dcn_get_msg_cnt(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.getMessageInfo = function (messageId) {
        debug("getMessageInfo " + messageId);
        return binding_1.default.dcn_get_msg_info(this.dcn_context, Number(messageId));
    };
    DeltaChat.prototype.getMessageHTML = function (messageId) {
        debug("getMessageHTML " + messageId);
        return binding_1.default.dcn_get_msg_html(this.dcn_context, Number(messageId));
    };
    DeltaChat.prototype.getNextMediaMessage = function (messageId, msgType1, msgType2, msgType3) {
        debug("getNextMediaMessage " + messageId + " " + msgType1 + " " + msgType2 + " " + msgType3);
        return this._getNextMedia(messageId, 1, msgType1, msgType2, msgType3);
    };
    DeltaChat.prototype.getPreviousMediaMessage = function (messageId, msgType1, msgType2, msgType3) {
        debug("getPreviousMediaMessage " + messageId + " " + msgType1 + " " + msgType2 + " " + msgType3);
        return this._getNextMedia(messageId, -1, msgType1, msgType2, msgType3);
    };
    DeltaChat.prototype._getNextMedia = function (messageId, dir, msgType1, msgType2, msgType3) {
        return binding_1.default.dcn_get_next_media(this.dcn_context, Number(messageId), dir, msgType1 || 0, msgType2 || 0, msgType3 || 0);
    };
    DeltaChat.getProviderFromEmail = function (email) {
        debug('DeltaChat.getProviderFromEmail');
        var dcn_context = DeltaChat.newTempContext();
        var provider = binding_1.default.dcn_provider_new_from_email(dcn_context, email);
        binding_1.default.dcn_context_unref(dcn_context);
        if (!provider) {
            return undefined;
        }
        return {
            before_login_hint: binding_1.default.dcn_provider_get_before_login_hint(provider),
            overview_page: binding_1.default.dcn_provider_get_overview_page(provider),
            status: binding_1.default.dcn_provider_get_status(provider),
        };
    };
    DeltaChat.prototype.getSecurejoinQrCode = function (chatId) {
        debug("getSecurejoinQrCode " + chatId);
        return binding_1.default.dcn_get_securejoin_qr(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.stopOngoingProcess = function () {
        debug("stopOngoingProcess");
        binding_1.default.dcn_stop_ongoing_process(this.dcn_context);
    };
    DeltaChat.newTempContext = function () {
        var dcn_context = binding_1.default.dcn_context_new(tempy_1.default.directory() + '/db.sqlite');
        return dcn_context;
    };
    DeltaChat.getSystemInfo = function () {
        debug('DeltaChat.getSystemInfo');
        var dcn_context = DeltaChat.newTempContext();
        var info = DeltaChat.parseGetInfo(binding_1.default.dcn_get_info(dcn_context));
        var result = lodash_pick_1.default(info, [
            'deltachat_core_version',
            'sqlite_version',
            'sqlite_thread_safe',
            'libetpan_version',
            'openssl_version',
            'compile_date',
            'arch',
        ]);
        binding_1.default.dcn_context_unref(dcn_context);
        return result;
    };
    DeltaChat.prototype.importExport = function (what, param1, param2) {
        if (param2 === void 0) { param2 = ''; }
        debug("importExport " + what + " " + param1 + " " + param2);
        binding_1.default.dcn_imex(this.dcn_context, what, param1, param2);
    };
    DeltaChat.prototype.importExportHasBackup = function (dir) {
        debug("importExportHasBackup " + dir);
        return binding_1.default.dcn_imex_has_backup(this.dcn_context, dir);
    };
    DeltaChat.prototype.initiateKeyTransfer = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            debug('initiateKeyTransfer2');
            binding_1.default.dcn_initiate_key_transfer(_this.dcn_context, resolve);
        });
    };
    DeltaChat.prototype.isConfigured = function () {
        debug('isConfigured');
        return Boolean(binding_1.default.dcn_is_configured(this.dcn_context));
    };
    DeltaChat.prototype.isContactInChat = function (chatId, contactId) {
        debug("isContactInChat " + chatId + " " + contactId);
        return Boolean(binding_1.default.dcn_is_contact_in_chat(this.dcn_context, Number(chatId), Number(contactId)));
    };
    /**
     *
     * @returns {Promise<number>} Promise that resolves into the resulting chat id
     */
    DeltaChat.prototype.joinSecurejoin = function (qrCode) {
        var _this = this;
        debug("joinSecurejoin " + qrCode);
        return new Promise(function (resolve, reject) {
            binding_1.default.dcn_join_securejoin(_this.dcn_context, qrCode, function (result) {
                if (result !== 0) {
                    resolve(result);
                }
                else {
                    reject('The out-of-band verification failed or was aborted');
                }
            });
        });
    };
    DeltaChat.prototype.lookupContactIdByAddr = function (addr) {
        debug("lookupContactIdByAddr " + addr);
        return binding_1.default.dcn_lookup_contact_id_by_addr(this.dcn_context, addr);
    };
    DeltaChat.prototype.markNoticedChat = function (chatId) {
        debug("markNoticedChat " + chatId);
        binding_1.default.dcn_marknoticed_chat(this.dcn_context, Number(chatId));
    };
    /** @deprecated */
    DeltaChat.prototype.markNoticedContact = function (contactId) {
        debug("markNoticedContact " + contactId);
        binding_1.default.dcn_marknoticed_contact(this.dcn_context, Number(contactId));
    };
    DeltaChat.prototype.markSeenMessages = function (messageIds) {
        if (!Array.isArray(messageIds)) {
            messageIds = [messageIds];
        }
        messageIds = messageIds.map(function (id) { return Number(id); });
        debug('markSeenMessages', messageIds);
        binding_1.default.dcn_markseen_msgs(this.dcn_context, messageIds);
    };
    DeltaChat.maybeValidAddr = function (addr) {
        debug('DeltaChat.maybeValidAddr');
        if (addr === null)
            return false;
        return Boolean(binding_1.default.dcn_maybe_valid_addr(addr));
    };
    DeltaChat.prototype.maybeNetwork = function () {
        debug('maybeNetwork');
        binding_1.default.dcn_maybe_network(this.dcn_context);
    };
    DeltaChat.prototype.messageNew = function (viewType) {
        if (viewType === void 0) { viewType = constants_1.C.DC_MSG_TEXT; }
        debug("messageNew " + viewType);
        return new message_1.Message(binding_1.default.dcn_msg_new(this.dcn_context, viewType));
    };
    DeltaChat.prototype.removeContactFromChat = function (chatId, contactId) {
        debug("removeContactFromChat " + chatId + " " + contactId);
        return Boolean(binding_1.default.dcn_remove_contact_from_chat(this.dcn_context, Number(chatId), Number(contactId)));
    };
    /**
     *
     * @param chatId 	ID of the chat to search messages in. Set this to 0 for a global search.
     * @param query The query to search for.
     */
    DeltaChat.prototype.searchMessages = function (chatId, query) {
        debug("searchMessages " + chatId + " " + query);
        return binding_1.default.dcn_search_msgs(this.dcn_context, Number(chatId), query);
    };
    DeltaChat.prototype.sendMessage = function (chatId, msg) {
        debug("sendMessage " + chatId);
        if (!msg) {
            throw new Error('invalid msg parameter');
        }
        if (typeof msg === 'string') {
            var msgObj = this.messageNew();
            msgObj.setText(msg);
            msg = msgObj;
        }
        if (!msg.dc_msg) {
            throw new Error('invalid msg object');
        }
        return binding_1.default.dcn_send_msg(this.dcn_context, Number(chatId), msg.dc_msg);
    };
    /**
     *
     * @returns {Promise<number>} Promise that resolves into the resulting message id
     */
    DeltaChat.prototype.sendVideochatInvitation = function (chatId) {
        var _this = this;
        debug("sendVideochatInvitation " + chatId);
        return new Promise(function (resolve, reject) {
            binding_1.default.dcn_send_videochat_invitation(_this.dcn_context, chatId, function (result) {
                if (result !== 0) {
                    resolve(result);
                }
                else {
                    reject('Videochatinvitation failed to send, see error events for detailed info');
                }
            });
        });
    };
    DeltaChat.prototype.setChatName = function (chatId, name) {
        debug("setChatName " + chatId + " " + name);
        return Boolean(binding_1.default.dcn_set_chat_name(this.dcn_context, Number(chatId), name));
    };
    /**
     *
     * @param chatId
     * @param protect
     * @returns success boolean
     */
    DeltaChat.prototype.setChatProtection = function (chatId, protect) {
        debug("setChatProtection " + chatId + " " + protect);
        return Boolean(binding_1.default.dcn_set_chat_protection(this.dcn_context, Number(chatId), protect ? 1 : 0));
    };
    DeltaChat.prototype.getChatEphemeralTimer = function (chatId) {
        debug("getChatEphemeralTimer " + chatId);
        return binding_1.default.dcn_get_chat_ephemeral_timer(this.dcn_context, Number(chatId));
    };
    DeltaChat.prototype.setChatEphemeralTimer = function (chatId, timer) {
        debug("setChatEphemeralTimer " + chatId + " " + timer);
        return Boolean(binding_1.default.dcn_set_chat_ephemeral_timer(this.dcn_context, Number(chatId), Number(timer)));
    };
    DeltaChat.prototype.setChatProfileImage = function (chatId, image) {
        debug("setChatProfileImage " + chatId + " " + image);
        return Boolean(binding_1.default.dcn_set_chat_profile_image(this.dcn_context, Number(chatId), image || ''));
    };
    DeltaChat.prototype.setConfig = function (key, value) {
        debug("setConfig (string) " + key + " " + value);
        if (typeof value === 'boolean') {
            value = value === true ? '1' : '0';
        }
        else if (typeof value === 'number') {
            value = String(value);
        }
        return binding_1.default.dcn_set_config(this.dcn_context, key, value || '');
    };
    DeltaChat.prototype.estimateDeletionCount = function (fromServer, seconds) {
        debug("estimateDeletionCount fromServer: " + fromServer + " seconds: " + seconds);
        return binding_1.default.dcn_estimate_deletion_cnt(this.dcn_context, fromServer === true ? 1 : 0, seconds);
    };
    DeltaChat.prototype.setStockTranslation = function (stockId, stockMsg) {
        debug("setStockTranslation " + stockId + " " + stockMsg);
        return Boolean(binding_1.default.dcn_set_stock_translation(this.dcn_context, Number(stockId), stockMsg));
    };
    DeltaChat.prototype.setDraft = function (chatId, msg) {
        debug("setDraft " + chatId);
        binding_1.default.dcn_set_draft(this.dcn_context, Number(chatId), msg ? msg.dc_msg : null);
    };
    DeltaChat.prototype.setLocation = function (latitude, longitude, accuracy) {
        debug("setLocation " + latitude);
        binding_1.default.dcn_set_location(this.dcn_context, Number(latitude), Number(longitude), Number(accuracy));
    };
    /*
     * @param chatId Chat-id to get location information for.
     *     0 to get locations independently of the chat.
     * @param contactId Contact id to get location information for.
     *     If also a chat-id is given, this should be a member of the given chat.
     *     0 to get locations independently of the contact.
     * @param timestampFrom Start of timespan to return.
     *     Must be given in number of seconds since 00:00 hours, Jan 1, 1970 UTC.
     *     0 for "start from the beginning".
     * @param timestampTo End of timespan to return.
     *     Must be given in number of seconds since 00:00 hours, Jan 1, 1970 UTC.
     *     0 for "all up to now".
     * @return Array of locations, NULL is never returned.
     *     The array is sorted decending;
     *     the first entry in the array is the location with the newest timestamp.
     *
     * Examples:
     * // get locations from the last hour for a global map
     * getLocations(0, 0, time(NULL)-60*60, 0);
     *
     * // get locations from a contact for a global map
     * getLocations(0, contact_id, 0, 0);
     *
     * // get all locations known for a given chat
     * getLocations(chat_id, 0, 0, 0);
     *
     * // get locations from a single contact for a given chat
     * getLocations(chat_id, contact_id, 0, 0);
     */
    DeltaChat.prototype.getLocations = function (chatId, contactId, timestampFrom, timestampTo) {
        if (timestampFrom === void 0) { timestampFrom = 0; }
        if (timestampTo === void 0) { timestampTo = 0; }
        var locations = new locations_1.Locations(binding_1.default.dcn_get_locations(this.dcn_context, Number(chatId), Number(contactId), timestampFrom, timestampTo));
        return locations.toJson();
    };
    /**
     *
     * @param duration The duration (0 for no mute, -1 for forever mute, everything else is is the relative mute duration from now in seconds)
     */
    DeltaChat.prototype.setChatMuteDuration = function (chatId, duration) {
        return Boolean(binding_1.default.dcn_set_chat_mute_duration(this.dcn_context, chatId, duration));
    };
    DeltaChat.createTempUser = function (url) {
        return __awaiter(this, void 0, void 0, function () {
            function postData(url) {
                if (url === void 0) { url = ''; }
                return __awaiter(this, void 0, void 0, function () {
                    var response;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0: return [4 /*yield*/, fetch(url, {
                                    method: 'POST',
                                    mode: 'cors',
                                    cache: 'no-cache',
                                    credentials: 'same-origin',
                                    headers: {
                                        'cache-control': 'no-cache',
                                    },
                                    referrerPolicy: 'no-referrer',
                                })];
                            case 1:
                                response = _a.sent();
                                return [2 /*return*/, response.json()]; // parses JSON response into native JavaScript objects
                        }
                    });
                });
            }
            var fetch;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        fetch = require('node-fetch');
                        return [4 /*yield*/, postData(url)];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    return DeltaChat;
}(events_1.EventEmitter));
exports.DeltaChat = DeltaChat;
//# sourceMappingURL=deltachat.js.map